<?php

namespace Drupal\access_policy;

/**
 * Access rule handler interface.
 *
 * Base interface for access rule handlers.
 */
interface AccessRuleHandlerInterface {

  /**
   * Initialize the access rule handler.
   *
   * @param \Drupal\access_policy\AccessRuleDefinition $definition
   *   The access rule definition.
   * @param string $operator
   *   The current operator.
   * @param mixed $value
   *   The current actual value.
   */
  public function initialize(AccessRuleDefinition $definition, $operator, $value);

}
