<?php

namespace Drupal\access_policy\Plugin\AccessPolicyType;

/**
 * Private access policy type.
 *
 * @AccessPolicyType(
 *   id = "private",
 *   label = @Translation("Private"),
 *   description = @Translation("Restrict view, edit and delete access to the original author."),
 *   weight = -1,
 *   operations = {
 *     "view" = {
 *       "rules" = true,
 *     },
 *     "view all revisions" = {
 *       "rules" = true,
 *     },
 *     "update" = {
 *       "rules" = true,
 *      },
 *     "delete" = {
 *       "rules" = true,
 *      },
 *     "assign access policy" = {
 *       "rules" = false,
 *      },
 *     "view unpublished" = {
 *       "rules" = true,
 *      },
 *   },
 *   access_rules = {
 *     "is_own" = {
 *       "id" = "is_own",
 *       "plugin_id" = "is_own",
 *       "field" = "uid",
 *       "settings" = {
 *          "query" = true,
 *          "operations" = { "view", "view all revisions", "update", "delete", "assign access policy", "view unpublished" }
 *       },
 *       "required" = true,
 *     },
 *   },
 * )
 */
class PrivateAccess extends AccessPolicyTypeBase {

}
