<?php

namespace Drupal\access_policy\Plugin\views;

use Drupal\views\Views;

/**
 * Assist views handler plugins to join to the access_policy entity.
 *
 * @internal
 */
trait AccessPolicyJoinViewsHandlerTrait {

  /**
   * {@inheritdoc}
   */
  public function ensureMyTable() {
    if (!isset($this->tableAlias)) {
      $table_alias = $this->query->ensureTable($this->table, $this->relationship);

      $left_entity_type = $this->entityTypeManager->getDefinition($this->getEntityType());
      $entity_type = $this->entityTypeManager->getDefinition('content_access_policy');
      $configuration = [
        'table' => $entity_type->getBaseTable(),
        'field' => 'content_entity_id',
        'left_table' => $table_alias,
        'left_field' => $left_entity_type->getKey('id'),
        'extra' => [
          [
            'field' => 'content_entity_type_id',
            'value' => $left_entity_type->id(),
          ],
        ],
      ];

      $join = Views::pluginManager('join')->createInstance('standard', $configuration);
      $this->tableAlias = $this->query->addRelationship('content_access_policy', $join, 'content_access_policy');
    }

    return $this->tableAlias;
  }

}
