<?php

namespace Drupal\access_policy\Plugin\views\field;

use Drupal\access_policy\Plugin\views\AccessPolicyJoinViewsHandlerTrait;
use Drupal\views\Plugin\views\field\EntityField;

/**
 * A field handler for the computed access_policy field.
 *
 * @ingroup views_field_handlers
 *
 * @ViewsField("access_policy_field")
 */
class AccessPolicyField extends EntityField {

  use AccessPolicyJoinViewsHandlerTrait;

  /**
   * {@inheritdoc}
   */
  public function clickSort($order) {
    $this->ensureMyTable();

    $storage = $this->entityTypeManager->getStorage('content_access_policy');
    $storage_definition = $this->entityFieldManager->getActiveFieldStorageDefinitions('content_access_policy')['access_policy'];
    $column_name = $storage->getTableMapping()->getFieldColumnName($storage_definition, 'value');
    $this->aliases[$column_name] = $this->tableAlias . '.' . $column_name;

    $this->query->addOrderBy(NULL, NULL, $order, $this->aliases[$column_name]);
  }

}
